// The Vue build version to load with the `import` command
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.
import Vue from 'vue'
import App from './App'
import router from './router'
import iView from 'iview';
import 'iview/dist/styles/iview.css';
import Vuex from 'vuex';

// 解决新版本报错开始
import {Switch} from 'iview'
Vue.component('i-switch',Switch)
// 解决新版本报错结束

Vue.config.productionTip = false
Vue.use(iView); // 使用iview

Vue.use(Vuex); // 使用vuex

/* Vuex */
const store = new Vuex.Store({
  state: { count: 0 }, // state中存放的就是共享的数据
  mutations: { // 定义mutations
    // 增加count的值
    add(state) { // 第一个参数永远都是State对象
      state.count++; // 使用state对count数据进行改变
    },
    sub(state) { // 减少count的值
      state.count--;
    },
    changeCount(state, num) { // 带有参数的mutation
      state.count += num;
    }
  },
  actions: { // 用来指定异步任务的操作
    syncChangeCount(context,num) { // context对象的commit方法用来执行mutations中的方法
      setTimeout(() => {  // 延时1.5秒再去提交执行changeCount方法
        context.commit('changeCount',num); 
      }, 1500);
    }
  },
  getters:{ // 对State中的数据进行加工处理后形成新的数据
    showCount: state => {
      return '当前的count值为:'+state.count;
    }
  }
})


/* eslint-disable no-new */
new Vue({
  el: '#app',
  router,
  components: { App },
  template: '<App/>',
  store,
})
